// Koka generated module: std/os/dir, koka version: 3.1.2, platform: 64-bit
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_exn__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32(mode,ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core_exn__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core_exn__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core_exn__exception kk_std_os_dir_prepend(kk_std_core_exn__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x_x315;
  kk_string_t _x_x316;
  kk_string_t _x_x317;
  kk_define_string_literal(, _s_x318, 2, ": ", _ctx)
  _x_x317 = kk_string_dup(_s_x318, _ctx); /*string*/
  kk_string_t _x_x319;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x_x319 = _x; /*string*/
  }
  _x_x316 = kk_std_core_types__lp__plus__plus__rp_(_x_x317, _x_x319, _ctx); /*string*/
  _x_x315 = kk_std_core_types__lp__plus__plus__rp_(pre, _x_x316, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x320;
  {
    kk_std_core_exn__exception_info _x_0 = exn.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(exn, _ctx);
    _x_x320 = _x_0; /*exception-info*/
  }
  return kk_std_core_exn__new_Exception(_x_x315, _x_x320, _ctx);
}

kk_std_core_exn__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun322__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun322(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun322(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun322, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun322(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x323;
  kk_std_os_path__path _x_x324 = kk_std_os_path__path_unbox(_b_x2, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x323 = kk_std_os_path_string(_x_x324, _ctx); /*string*/
  return kk_string_box(_x_x323);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun328__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun328(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun328(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun328, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun328(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x329;
  kk_std_os_path__path _x_x330 = kk_std_os_path__path_unbox(_b_x7, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x329 = kk_std_os_path_string(_x_x330, _ctx); /*string*/
  return kk_string_box(_x_x329);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun334__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun334(kk_function_t _fself, kk_box_t _b_x15, kk_box_t _b_x16, kk_box_t _b_x17, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun334(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun334, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun334(kk_function_t _fself, kk_box_t _b_x15, kk_box_t _b_x16, kk_box_t _b_x17, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__error _x_x335;
  kk_string_t _x_x336 = kk_string_unbox(_b_x15); /*string*/
  kk_string_t _x_x337 = kk_string_unbox(_b_x16); /*string*/
  bool _x_x338 = kk_bool_unbox(_b_x17); /*bool*/
  _x_x335 = kk_std_os_dir_prim_copy_file(_x_x336, _x_x337, _x_x338, _ctx); /*error<()>*/
  return kk_std_core_exn__error_box(_x_x335, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun346__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun346(kk_function_t _fself, kk_box_t _b_x20, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun346(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun346, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun346(kk_function_t _fself, kk_box_t _b_x20, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x347;
  kk_string_t _x_x348;
  kk_std_os_path__path _x_x349 = kk_std_os_path__path_unbox(_b_x20, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x348 = kk_std_os_path_string(_x_x349, _ctx); /*string*/
  _x_x347 = kk_std_core_show_string_fs_show(_x_x348, _ctx); /*string*/
  return kk_string_box(_x_x347);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun355__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun355(kk_function_t _fself, kk_box_t _b_x23, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun355(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun355, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun355(kk_function_t _fself, kk_box_t _b_x23, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path p_0_51 = kk_std_os_path__path_unbox(_b_x23, KK_OWNED, _ctx); /*std/os/path/path*/;
  kk_string_t _x_x356;
  kk_string_t _x_x357 = kk_std_os_path_string(p_0_51, _ctx); /*string*/
  _x_x356 = kk_std_core_show_string_fs_show(_x_x357, _ctx); /*string*/
  return kk_string_box(_x_x356);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun359__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun359(kk_function_t _fself, kk_box_t _b_x31, kk_box_t _b_x32, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun359(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun359, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun359(kk_function_t _fself, kk_box_t _b_x31, kk_box_t _b_x32, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__exception _x_x360;
  kk_string_t _x_x361;
  kk_string_t _x_x362 = kk_string_unbox(_b_x32); /*string*/
  kk_string_t _x_x363;
  kk_string_t _x_x364;
  kk_define_string_literal(, _s_x365, 2, ": ", _ctx)
  _x_x364 = kk_string_dup(_s_x365, _ctx); /*string*/
  kk_string_t _x_x366;
  kk_std_core_exn__exception _match_x314;
  kk_box_t _x_x367 = kk_box_dup(_b_x31, _ctx); /*8645*/
  _match_x314 = kk_std_core_exn__exception_unbox(_x_x367, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_x314.message;
    kk_string_dup(_x, _ctx);
    kk_std_core_exn__exception_drop(_match_x314, _ctx);
    _x_x366 = _x; /*string*/
  }
  _x_x363 = kk_std_core_types__lp__plus__plus__rp_(_x_x364, _x_x366, _ctx); /*string*/
  _x_x361 = kk_std_core_types__lp__plus__plus__rp_(_x_x362, _x_x363, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x368;
  kk_std_core_exn__exception _match_x313 = kk_std_core_exn__exception_unbox(_b_x31, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core_exn__exception_info _x_0 = _match_x313.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(_match_x313, _ctx);
    _x_x368 = _x_0; /*exception-info*/
  }
  _x_x360 = kk_std_core_exn__new_Exception(_x_x361, _x_x368, _ctx); /*exception*/
  return kk_std_core_exn__exception_box(_x_x360, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : ? bool) -> <exn,fsys> () */ 
  kk_string_t _x_x1_10043;
  kk_box_t _x_x321;
  kk_box_t _x_x325;
  kk_std_os_path__path _x_x326 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x_x325 = kk_std_os_path__path_box(_x_x326, _ctx); /*8579*/
  _x_x321 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun322(_ctx), _x_x325, _ctx); /*8580*/
  _x_x1_10043 = kk_string_unbox(_x_x321); /*string*/
  kk_string_t _x_x2_10044;
  kk_box_t _x_x327;
  kk_box_t _x_x331;
  kk_std_os_path__path _x_x332 = kk_std_os_path__path_dup(to, _ctx); /*std/os/path/path*/
  _x_x331 = kk_std_os_path__path_box(_x_x332, _ctx); /*8579*/
  _x_x327 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun328(_ctx), _x_x331, _ctx); /*8580*/
  _x_x2_10044 = kk_string_unbox(_x_x327); /*string*/
  kk_std_core_exn__error _match_x310;
  kk_box_t _x_x333;
  kk_box_t _x_x339;
  bool _x_x340;
  if (kk_std_core_types__is_Optional(preserve_mtime, _ctx)) {
    kk_box_t _box_x10 = preserve_mtime._cons._Optional.value;
    bool _uniq_preserve_mtime_101 = kk_bool_unbox(_box_x10);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x_x340 = _uniq_preserve_mtime_101; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x_x340 = true; /*bool*/
  }
  _x_x339 = kk_bool_box(_x_x340); /*8724*/
  _x_x333 = kk_std_core_hnd__open_none3(kk_std_os_dir_new_copy_file_fun334(_ctx), kk_string_box(_x_x1_10043), kk_string_box(_x_x2_10044), _x_x339, _ctx); /*8725*/
  _match_x310 = kk_std_core_exn__error_unbox(_x_x333, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core_exn__is_Error(_match_x310, _ctx)) {
    kk_std_core_exn__exception exn = _match_x310._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(_match_x310, _ctx);
    kk_string_t _x_x2_0_10049;
    kk_string_t _x_x341;
    kk_define_string_literal(, _s_x342, 15, "unable to copy ", _ctx)
    _x_x341 = kk_string_dup(_s_x342, _ctx); /*string*/
    kk_string_t _x_x343;
    kk_string_t _x_x344;
    kk_box_t _x_x345 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun346(_ctx), kk_std_os_path__path_box(from, _ctx), _ctx); /*8580*/
    _x_x344 = kk_string_unbox(_x_x345); /*string*/
    kk_string_t _x_x350;
    kk_string_t _x_x351;
    kk_define_string_literal(, _s_x352, 4, " to ", _ctx)
    _x_x351 = kk_string_dup(_s_x352, _ctx); /*string*/
    kk_string_t _x_x353;
    kk_box_t _x_x354 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun355(_ctx), kk_std_os_path__path_box(to, _ctx), _ctx); /*8580*/
    _x_x353 = kk_string_unbox(_x_x354); /*string*/
    _x_x350 = kk_std_core_types__lp__plus__plus__rp_(_x_x351, _x_x353, _ctx); /*string*/
    _x_x343 = kk_std_core_types__lp__plus__plus__rp_(_x_x344, _x_x350, _ctx); /*string*/
    _x_x2_0_10049 = kk_std_core_types__lp__plus__plus__rp_(_x_x341, _x_x343, _ctx); /*string*/
    kk_std_core_exn__exception exn_0_10002;
    kk_box_t _x_x358 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_fun359(_ctx), kk_std_core_exn__exception_box(exn, _ctx), kk_string_box(_x_x2_0_10049), _ctx); /*8647*/
    exn_0_10002 = kk_std_core_exn__exception_unbox(_x_x358, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_10071 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x369;
    {
      struct kk_std_core_hnd_Ev* _con_x370 = kk_std_core_hnd__as_Ev(ev_10071, _ctx);
      kk_box_t _box_x38 = _con_x370->hnd;
      int32_t m = _con_x370->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x38, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x311;
      kk_std_core_hnd__clause1 _brw_x312 = kk_std_core_exn__select_throw_exn(h, _ctx); /*hnd/clause1<exception,403,exn,404,405>*/;
      kk_std_core_exn__exn_drop(h, _ctx);
      _match_x311 = _brw_x312; /*hnd/clause1<exception,403,exn,404,405>*/
      {
        kk_function_t _fun_unbox_x42 = _match_x311.clause;
        _x_x369 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x42, (_fun_unbox_x42, m, ev_10071, kk_std_core_exn__exception_box(exn_0_10002, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x369); return kk_Unit;
  }
  {
    kk_std_os_path__path_drop(to, _ctx);
    kk_std_os_path__path_drop(from, _ctx);
    kk_std_core_exn__error_drop(_match_x310, _ctx);
    kk_Unit; return kk_Unit;
  }
}

kk_std_core_exn__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun372__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun372(kk_function_t _fself, kk_box_t _b_x54, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun372(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun372, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun372(kk_function_t _fself, kk_box_t _b_x54, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x373;
  kk_std_os_path__path _x_x374 = kk_std_os_path__path_unbox(_b_x54, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x373 = kk_std_os_path_string(_x_x374, _ctx); /*string*/
  return kk_string_box(_x_x373);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun378__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun378(kk_function_t _fself, kk_box_t _b_x60, kk_box_t _b_x61, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun378(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun378, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun378(kk_function_t _fself, kk_box_t _b_x60, kk_box_t _b_x61, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__error _x_x379;
  kk_string_t _x_x380 = kk_string_unbox(_b_x60); /*string*/
  kk_integer_t _x_x381 = kk_integer_unbox(_b_x61, _ctx); /*int*/
  _x_x379 = kk_std_os_dir_ensure_dir_err(_x_x380, _x_x381, _ctx); /*error<()>*/
  return kk_std_core_exn__error_box(_x_x379, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun386__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun386(kk_function_t _fself, kk_box_t _b_x64, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun386(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun386, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun386(kk_function_t _fself, kk_box_t _b_x64, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x387;
  kk_string_t _x_x388;
  kk_std_os_path__path _x_x389 = kk_std_os_path__path_unbox(_b_x64, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x388 = kk_std_os_path_string(_x_x389, _ctx); /*string*/
  _x_x387 = kk_std_core_show_string_fs_show(_x_x388, _ctx); /*string*/
  return kk_string_box(_x_x387);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun391__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun391(kk_function_t _fself, kk_box_t _b_x71, kk_box_t _b_x72, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun391(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun391, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun391(kk_function_t _fself, kk_box_t _b_x71, kk_box_t _b_x72, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__exception _x_x392;
  kk_string_t _x_x393;
  kk_string_t _x_x394 = kk_string_unbox(_b_x72); /*string*/
  kk_string_t _x_x395;
  kk_string_t _x_x396;
  kk_define_string_literal(, _s_x397, 2, ": ", _ctx)
  _x_x396 = kk_string_dup(_s_x397, _ctx); /*string*/
  kk_string_t _x_x398;
  kk_std_core_exn__exception _match_x309;
  kk_box_t _x_x399 = kk_box_dup(_b_x71, _ctx); /*8645*/
  _match_x309 = kk_std_core_exn__exception_unbox(_x_x399, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_x309.message;
    kk_string_dup(_x, _ctx);
    kk_std_core_exn__exception_drop(_match_x309, _ctx);
    _x_x398 = _x; /*string*/
  }
  _x_x395 = kk_std_core_types__lp__plus__plus__rp_(_x_x396, _x_x398, _ctx); /*string*/
  _x_x393 = kk_std_core_types__lp__plus__plus__rp_(_x_x394, _x_x395, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x400;
  kk_std_core_exn__exception _match_x308 = kk_std_core_exn__exception_unbox(_b_x71, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core_exn__exception_info _x_0 = _match_x308.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(_match_x308, _ctx);
    _x_x400 = _x_0; /*exception-info*/
  }
  _x_x392 = kk_std_core_exn__new_Exception(_x_x393, _x_x400, _ctx); /*exception*/
  return kk_std_core_exn__exception_box(_x_x392, _ctx);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x_x1_10052;
  kk_box_t _x_x371;
  kk_box_t _x_x375;
  kk_std_os_path__path _x_x376 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x_x375 = kk_std_os_path__path_box(_x_x376, _ctx); /*8579*/
  _x_x371 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun372(_ctx), _x_x375, _ctx); /*8580*/
  _x_x1_10052 = kk_string_unbox(_x_x371); /*string*/
  kk_std_core_exn__error _match_x305;
  kk_box_t _x_x377 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun378(_ctx), kk_string_box(_x_x1_10052), kk_integer_box(kk_integer_from_small(-1), _ctx), _ctx); /*8647*/
  _match_x305 = kk_std_core_exn__error_unbox(_x_x377, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core_exn__is_Error(_match_x305, _ctx)) {
    kk_std_core_exn__exception exn = _match_x305._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(_match_x305, _ctx);
    kk_string_t _x_x2_0_10056;
    kk_string_t _x_x382;
    kk_define_string_literal(, _s_x383, 27, "unable to create directory ", _ctx)
    _x_x382 = kk_string_dup(_s_x383, _ctx); /*string*/
    kk_string_t _x_x384;
    kk_box_t _x_x385 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun386(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*8580*/
    _x_x384 = kk_string_unbox(_x_x385); /*string*/
    _x_x2_0_10056 = kk_std_core_types__lp__plus__plus__rp_(_x_x382, _x_x384, _ctx); /*string*/
    kk_std_core_exn__exception exn_0_10005;
    kk_box_t _x_x390 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun391(_ctx), kk_std_core_exn__exception_box(exn, _ctx), kk_string_box(_x_x2_0_10056), _ctx); /*8647*/
    exn_0_10005 = kk_std_core_exn__exception_unbox(_x_x390, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_10074 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x401;
    {
      struct kk_std_core_hnd_Ev* _con_x402 = kk_std_core_hnd__as_Ev(ev_10074, _ctx);
      kk_box_t _box_x78 = _con_x402->hnd;
      int32_t m = _con_x402->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x78, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x306;
      kk_std_core_hnd__clause1 _brw_x307 = kk_std_core_exn__select_throw_exn(h, _ctx); /*hnd/clause1<exception,403,exn,404,405>*/;
      kk_std_core_exn__exn_drop(h, _ctx);
      _match_x306 = _brw_x307; /*hnd/clause1<exception,403,exn,404,405>*/
      {
        kk_function_t _fun_unbox_x82 = _match_x306.clause;
        _x_x401 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x82, (_fun_unbox_x82, m, ev_10074, kk_std_core_exn__exception_box(exn_0_10005, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x401); return kk_Unit;
  }
  {
    kk_box_t _box_x86 = _match_x305._cons.Ok.result;
    kk_unit_t _pat_3_0 = kk_unit_unbox(_box_x86);
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core_exn__error_drop(_match_x305, _ctx);
    kk_Unit; return kk_Unit;
  }
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core_exn__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).


// lift anonymous function
struct kk_std_os_dir_list_directory_fun406__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir;
};
static kk_box_t kk_std_os_dir_list_directory_fun406(kk_function_t _fself, kk_box_t _b_x93, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_fun406(kk_std_os_path__path dir, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun406__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_fun406__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_list_directory_fun406, kk_context());
  _self->dir = dir;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_list_directory_fun406(kk_function_t _fself, kk_box_t _b_x93, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun406__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_fun406__t*, _fself, _ctx);
  kk_std_os_path__path dir = _self->dir; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir, _ctx);}, {}, _ctx)
  kk_string_t name_96 = kk_string_unbox(_b_x93); /*string*/;
  kk_std_os_path__path _x_x407;
  kk_std_os_path__path _x_x408 = kk_std_os_path_path(name_96, _ctx); /*std/os/path/path*/
  _x_x407 = kk_std_os_path__lp__fs__rp_(dir, _x_x408, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x407, _ctx);
}

kk_std_core_types__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core_exn__error _match_x304;
  kk_string_t _x_x404;
  kk_std_os_path__path _x_x405 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x_x404 = kk_std_os_path_string(_x_x405, _ctx); /*string*/
  _match_x304 = kk_std_os_dir_prim_list_dir(_x_x404, _ctx); /*error<vector<string>>*/
  if (kk_std_core_exn__is_Error(_match_x304, _ctx)) {
    kk_std_core_exn__exception _pat_0 = _match_x304._cons.Error.exception;
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core_exn__error_drop(_match_x304, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_box_t _box_x90 = _match_x304._cons.Ok.result;
    kk_vector_t contents = kk_vector_unbox(_box_x90, _ctx);
    kk_vector_dup(contents, _ctx);
    kk_std_core_exn__error_drop(_match_x304, _ctx);
    kk_std_core_types__list _b_x91_94 = kk_std_core_vector_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
    return kk_std_core_list_map(_b_x91_94, kk_std_os_dir_new_list_directory_fun406(dir, _ctx), _ctx);
  }
}
 
// Recursively list all the entries under a directory.


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun410__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_list_directory_recursive_fun410(kk_function_t _fself, kk_box_t _b_x100, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun410(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_list_directory_recursive_fun410, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static bool kk_std_os_dir_list_directory_recursive_fun410(kk_function_t _fself, kk_box_t _b_x100, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x_x411 = kk_std_os_path__path_unbox(_b_x100, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_is_directory(_x_x411, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun412__t {
  struct kk_function_s _base;
  kk_std_core_types__optional max_depth;
};
static kk_std_core_types__list kk_std_os_dir_list_directory_recursive_fun412(kk_function_t _fself, kk_box_t _b_x107, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun412(kk_std_core_types__optional max_depth, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun412__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_recursive_fun412__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_list_directory_recursive_fun412, kk_context());
  _self->max_depth = max_depth;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__list kk_std_os_dir_list_directory_recursive_fun412(kk_function_t _fself, kk_box_t _b_x107, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun412__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_recursive_fun412__t*, _fself, _ctx);
  kk_std_core_types__optional max_depth = _self->max_depth; /* ? int */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(max_depth, _ctx);}, {}, _ctx)
  kk_integer_t _b_x104_110;
  kk_integer_t _x_x413;
  if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
    kk_box_t _box_x103 = max_depth._cons._Optional.value;
    kk_integer_t _uniq_max_depth_431_0 = kk_integer_unbox(_box_x103, _ctx);
    kk_integer_dup(_uniq_max_depth_431_0, _ctx);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    _x_x413 = _uniq_max_depth_431_0; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    _x_x413 = kk_integer_from_small(1000); /*int*/
  }
  _b_x104_110 = kk_integer_add_small_const(_x_x413, -1, _ctx); /*int*/
  kk_std_os_path__path _x_x414 = kk_std_os_path__path_unbox(_b_x107, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_core_types__optional _x_x415 = kk_std_core_types__new_Optional(kk_integer_box(_b_x104_110, _ctx), _ctx); /*? 7*/
  return kk_std_os_dir_list_directory_recursive(_x_x414, _x_x415, _ctx);
}

kk_std_core_types__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir, kk_std_core_types__optional max_depth, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : ? int) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_x301;
  kk_integer_t _brw_x302;
  if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
    kk_box_t _box_x97 = max_depth._cons._Optional.value;
    kk_integer_t _uniq_max_depth_431 = kk_integer_unbox(_box_x97, _ctx);
    kk_integer_dup(_uniq_max_depth_431, _ctx);
    _brw_x302 = _uniq_max_depth_431; /*int*/
  }
  else {
    _brw_x302 = kk_integer_from_small(1000); /*int*/
  }
  bool _brw_x303 = kk_integer_lt_borrow(_brw_x302,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_x302, _ctx);
  _match_x301 = _brw_x303; /*bool*/
  if (_match_x301) {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core_types__new_Nil(_ctx);
  }
  {
    kk_std_core_types__list all = kk_std_os_dir_list_directory(dir, _ctx); /*list<std/os/path/path>*/;
    kk_std_core_types__list dirs;
    kk_std_core_types__list _x_x409 = kk_std_core_types__list_dup(all, _ctx); /*list<std/os/path/path>*/
    dirs = kk_std_core_list_filter(_x_x409, kk_std_os_dir_new_list_directory_recursive_fun410(_ctx), _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__list ys_10010 = kk_std_core_list_flatmap(dirs, kk_std_os_dir_new_list_directory_recursive_fun412(max_depth, _ctx), _ctx); /*list<std/os/path/path>*/;
    return kk_std_core_list_append(all, ys_10010, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10068_fun416__t {
  struct kk_function_s _base;
  kk_std_os_path__path to;
};
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10068_fun416(kk_function_t _fself, kk_box_t _b_x128, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10068_fun416(kk_std_os_path__path to, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10068_fun416__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10068_fun416__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10068_fun416, kk_context());
  _self->to = to;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10068_fun418__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun418(kk_function_t _fself, kk_box_t _b_x117, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10068_fun418(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10068_fun418, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun418(kk_function_t _fself, kk_box_t _b_x117, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _b_x112_113;
  kk_std_core_types__list _x_x419;
  kk_std_os_path__path _match_x300;
  kk_box_t _x_x420 = kk_box_dup(_b_x117, _ctx); /*8579*/
  _match_x300 = kk_std_os_path__path_unbox(_x_x420, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1_0 = _match_x300.parts;
    kk_std_core_types__list_dup(_x_1_0, _ctx);
    kk_std_os_path__path_drop(_match_x300, _ctx);
    _x_x419 = _x_1_0; /*list<string>*/
  }
  _b_x112_113 = kk_std_core_list_take(_x_x419, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x421;
  kk_string_t _x_x422 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x424;
  kk_std_core_types__optional _match_x298 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x112_113, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x298, _ctx)) {
    kk_box_t _box_x114 = _match_x298._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_115_0 = kk_std_core_types__list_unbox(_box_x114, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_115_0, _ctx);
    kk_std_core_types__optional_drop(_match_x298, _ctx);
    kk_box_drop(_b_x117, _ctx);
    _x_x424 = _uniq_parts_115_0; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x298, _ctx);
    kk_std_os_path__path _match_x299 = kk_std_os_path__path_unbox(_b_x117, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0_0 = _match_x299.parts;
      kk_std_core_types__list_dup(_x_0_0, _ctx);
      kk_std_os_path__path_drop(_match_x299, _ctx);
      _x_x424 = _x_0_0; /*list<string>*/
    }
  }
  _x_x421 = kk_std_os_path__new_Path(_x_x422, _x_x424, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x421, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10068_fun429__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun429(kk_function_t _fself, kk_box_t _b_x124, kk_box_t _b_x125, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10068_fun429(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10068_fun429, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10068_fun429(kk_function_t _fself, kk_box_t _b_x124, kk_box_t _b_x125, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x_x430;
  kk_std_os_path__path _x_x431 = kk_std_os_path__path_unbox(_b_x124, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x432 = kk_std_os_path__path_unbox(_b_x125, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x430 = kk_std_os_path__lp__fs__rp_(_x_x431, _x_x432, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x430, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10068_fun416(kk_function_t _fself, kk_box_t _b_x128, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10068_fun416__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10068_fun416__t*, _fself, _ctx);
  kk_std_os_path__path to = _self->to; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_0_10063;
  kk_box_t _x_x417;
  kk_box_t _x_x425 = kk_box_dup(_b_x128, _ctx); /*2691*/
  _x_x417 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10068_fun418(_ctx), _x_x425, _ctx); /*8580*/
  _x_x2_0_10063 = kk_std_os_path__path_unbox(_x_x417, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x426 = kk_std_os_path__path_unbox(_b_x128, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x427;
  kk_box_t _x_x428 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift_copy_directory_10068_fun429(_ctx), kk_std_os_path__path_box(to, _ctx), kk_std_os_path__path_box(_x_x2_0_10063, _ctx), _ctx); /*8647*/
  _x_x427 = kk_std_os_path__path_unbox(_x_x428, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_directory(_x_x426, _x_x427, _ctx); return kk_Unit;
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10068(kk_std_core_types__list dirs, kk_std_os_path__path to, kk_unit_t wild___0, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_@0 : ()) -> <exn,fsys,div> () */ 
  kk_std_core_list_foreach(dirs, kk_std_os_dir__new_mlift_copy_directory_10068_fun416(to, _ctx), _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun434__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_0;
};
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10069_fun434(kk_function_t _fself, kk_box_t _b_x153, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun434(kk_std_os_path__path to_0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun434__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun434__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10069_fun434, kk_context());
  _self->to_0 = to_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun436__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun436(kk_function_t _fself, kk_box_t _b_x142, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun436(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10069_fun436, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun436(kk_function_t _fself, kk_box_t _b_x142, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _b_x137_138;
  kk_std_core_types__list _x_x437;
  kk_std_os_path__path _match_x297;
  kk_box_t _x_x438 = kk_box_dup(_b_x142, _ctx); /*8579*/
  _match_x297 = kk_std_os_path__path_unbox(_x_x438, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1 = _match_x297.parts;
    kk_std_core_types__list_dup(_x_1, _ctx);
    kk_std_os_path__path_drop(_match_x297, _ctx);
    _x_x437 = _x_1; /*list<string>*/
  }
  _b_x137_138 = kk_std_core_list_take(_x_x437, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x439;
  kk_string_t _x_x440 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x442;
  kk_std_core_types__optional _match_x295 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x137_138, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x295, _ctx)) {
    kk_box_t _box_x139 = _match_x295._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_115 = kk_std_core_types__list_unbox(_box_x139, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_115, _ctx);
    kk_std_core_types__optional_drop(_match_x295, _ctx);
    kk_box_drop(_b_x142, _ctx);
    _x_x442 = _uniq_parts_115; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x295, _ctx);
    kk_std_os_path__path _match_x296 = kk_std_os_path__path_unbox(_b_x142, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0 = _match_x296.parts;
      kk_std_core_types__list_dup(_x_0, _ctx);
      kk_std_os_path__path_drop(_match_x296, _ctx);
      _x_x442 = _x_0; /*list<string>*/
    }
  }
  _x_x439 = kk_std_os_path__new_Path(_x_x440, _x_x442, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x439, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun447__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun447(kk_function_t _fself, kk_box_t _b_x149, kk_box_t _b_x150, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun447(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10069_fun447, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun447(kk_function_t _fself, kk_box_t _b_x149, kk_box_t _b_x150, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x_x448;
  kk_std_os_path__path _x_x449 = kk_std_os_path__path_unbox(_b_x149, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x450 = kk_std_os_path__path_unbox(_b_x150, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x448 = kk_std_os_path__lp__fs__rp_(_x_x449, _x_x450, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x448, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift_copy_directory_10069_fun434(kk_function_t _fself, kk_box_t _b_x153, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun434__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun434__t*, _fself, _ctx);
  kk_std_os_path__path to_0 = _self->to_0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_0, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_10060;
  kk_box_t _x_x435;
  kk_box_t _x_x443 = kk_box_dup(_b_x153, _ctx); /*2691*/
  _x_x435 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10069_fun436(_ctx), _x_x443, _ctx); /*8580*/
  _x_x2_10060 = kk_std_os_path__path_unbox(_x_x435, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x444 = kk_std_os_path__path_unbox(_b_x153, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x445;
  kk_box_t _x_x446 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift_copy_directory_10069_fun447(_ctx), kk_std_os_path__path_box(to_0, _ctx), kk_std_os_path__path_box(_x_x2_10060, _ctx), _ctx); /*8647*/
  _x_x445 = kk_std_os_path__path_unbox(_x_x446, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x_x444, _x_x445, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10069_fun452__t {
  struct kk_function_s _base;
  kk_std_core_types__list dirs_0;
  kk_std_os_path__path to_0;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun452(kk_function_t _fself, kk_box_t _b_x161, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10069_fun452(kk_std_core_types__list dirs_0, kk_std_os_path__path to_0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun452__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun452__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10069_fun452, kk_context());
  _self->dirs_0 = dirs_0;
  _self->to_0 = to_0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10069_fun452(kk_function_t _fself, kk_box_t _b_x161, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10069_fun452__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10069_fun452__t*, _fself, _ctx);
  kk_std_core_types__list dirs_0 = _self->dirs_0; /* list<std/os/path/path> */
  kk_std_os_path__path to_0 = _self->to_0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(dirs_0, _ctx);kk_std_os_path__path_dup(to_0, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_0_163 = kk_Unit;
  kk_unit_unbox(_b_x161);
  kk_unit_t _x_x453 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10068(dirs_0, to_0, wild___0_0_163, _ctx);
  return kk_unit_box(_x_x453);
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10069(kk_std_os_path__path to_0, kk_std_core_types__tuple2 _y_x10018, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  {
    kk_box_t _box_x135 = _y_x10018.fst;
    kk_box_t _box_x136 = _y_x10018.snd;
    kk_std_core_types__list dirs_0 = kk_std_core_types__list_unbox(_box_x135, KK_BORROWED, _ctx);
    kk_std_core_types__list files = kk_std_core_types__list_unbox(_box_x136, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(dirs_0, _ctx);
    kk_std_core_types__list_dup(files, _ctx);
    kk_std_core_types__tuple2_drop(_y_x10018, _ctx);
    kk_unit_t x_10077 = kk_Unit;
    kk_function_t _x_x433;
    kk_std_os_path__path_dup(to_0, _ctx);
    _x_x433 = kk_std_os_dir__new_mlift_copy_directory_10069_fun434(to_0, _ctx); /*(2691) -> 2692 ()*/
    kk_std_core_list_foreach(files, _x_x433, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x_x451 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift_copy_directory_10069_fun452(dirs_0, to_0, _ctx), _ctx); /*2978*/
      kk_unit_unbox(_x_x451); return kk_Unit;
    }
    {
      kk_std_os_dir__mlift_copy_directory_10068(dirs_0, to_0, x_10077, _ctx); return kk_Unit;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun455__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun455(kk_function_t _fself, kk_box_t _b_x166, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun455(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10070_fun455, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun455(kk_function_t _fself, kk_box_t _b_x166, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _x_x456;
  kk_std_os_path__path _x_x457 = kk_std_os_path__path_unbox(_b_x166, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x456 = kk_std_os_dir_list_directory(_x_x457, _ctx); /*list<std/os/path/path>*/
  return kk_std_core_types__list_box(_x_x456, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun458__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift_copy_directory_10070_fun458(kk_function_t _fself, kk_box_t _b_x174, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun458(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10070_fun458, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun460__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun460(kk_function_t _fself, kk_box_t _b_x171, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun460(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift_copy_directory_10070_fun460, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun460(kk_function_t _fself, kk_box_t _b_x171, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x_x461;
  kk_std_os_path__path _x_x462 = kk_std_os_path__path_unbox(_b_x171, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x461 = kk_std_os_dir_is_directory(_x_x462, _ctx); /*bool*/
  return kk_bool_box(_x_x461);
}
static bool kk_std_os_dir__mlift_copy_directory_10070_fun458(kk_function_t _fself, kk_box_t _b_x174, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _x_x459 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10070_fun460(_ctx), _b_x174, _ctx); /*8580*/
  return kk_bool_unbox(_x_x459);
}


// lift anonymous function
struct kk_std_os_dir__mlift_copy_directory_10070_fun464__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_1;
};
static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun464(kk_function_t _fself, kk_box_t _b_x181, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift_copy_directory_10070_fun464(kk_std_os_path__path to_1, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10070_fun464__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift_copy_directory_10070_fun464__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift_copy_directory_10070_fun464, kk_context());
  _self->to_1 = to_1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift_copy_directory_10070_fun464(kk_function_t _fself, kk_box_t _b_x181, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift_copy_directory_10070_fun464__t* _self = kk_function_as(struct kk_std_os_dir__mlift_copy_directory_10070_fun464__t*, _fself, _ctx);
  kk_std_os_path__path to_1 = _self->to_1; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_1, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2 _y_x10018_0_183 = kk_std_core_types__tuple2_unbox(_b_x181, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x_x465 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10069(to_1, _y_x10018_0_183, _ctx);
  return kk_unit_box(_x_x465);
}

kk_unit_t kk_std_os_dir__mlift_copy_directory_10070(kk_std_os_path__path dir, kk_std_os_path__path to_1, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core_types__list all;
  kk_box_t _x_x454 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift_copy_directory_10070_fun455(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*8580*/
  all = kk_std_core_types__list_unbox(_x_x454, KK_OWNED, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2 x_0_10079;
  kk_function_t _brw_x292 = kk_std_os_dir__new_mlift_copy_directory_10070_fun458(_ctx); /*(2453) -> 2454 bool*/;
  kk_std_core_types__tuple2 _brw_x293 = kk_std_core_list_partition(all, _brw_x292, _ctx); /*(list<2453>, list<2453>)*/;
  kk_function_drop(_brw_x292, _ctx);
  x_0_10079 = _brw_x293; /*(list<std/os/path/path>, list<std/os/path/path>)*/
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2_drop(x_0_10079, _ctx);
    kk_box_t _x_x463 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift_copy_directory_10070_fun464(to_1, _ctx), _ctx); /*2978*/
    kk_unit_unbox(_x_x463); return kk_Unit;
  }
  {
    kk_std_os_dir__mlift_copy_directory_10069(to_1, x_0_10079, _ctx); return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun468__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir_0;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun468(kk_function_t _fself, kk_box_t _b_x185, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun468(kk_std_os_path__path dir_0, kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun468__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun468__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun468, kk_context());
  _self->dir_0 = dir_0;
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun468(kk_function_t _fself, kk_box_t _b_x185, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun468__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun468__t*, _fself, _ctx);
  kk_std_os_path__path dir_0 = _self->dir_0; /* std/os/path/path */
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir_0, _ctx);kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_unit_t wild___1_256 = kk_Unit;
  kk_unit_unbox(_b_x185);
  kk_unit_t _x_x469 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10070(dir_0, to_2, wild___1_256, _ctx);
  return kk_unit_box(_x_x469);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun471__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun471(kk_function_t _fself, kk_box_t _b_x188, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun471(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun471, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun471(kk_function_t _fself, kk_box_t _b_x188, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _x_x472;
  kk_std_os_path__path _x_x473 = kk_std_os_path__path_unbox(_b_x188, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x472 = kk_std_os_dir_list_directory(_x_x473, _ctx); /*list<std/os/path/path>*/
  return kk_std_core_types__list_box(_x_x472, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun474__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun474(kk_function_t _fself, kk_box_t _b_x196, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun474(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun474, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun476__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun476(kk_function_t _fself, kk_box_t _b_x193, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun476(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun476, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun476(kk_function_t _fself, kk_box_t _b_x193, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x_x477;
  kk_std_os_path__path _x_x478 = kk_std_os_path__path_unbox(_b_x193, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x477 = kk_std_os_dir_is_directory(_x_x478, _ctx); /*bool*/
  return kk_bool_box(_x_x477);
}
static bool kk_std_os_dir_copy_directory_fun474(kk_function_t _fself, kk_box_t _b_x196, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _x_x475 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun476(_ctx), _b_x196, _ctx); /*8580*/
  return kk_bool_unbox(_x_x475);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun480__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun480(kk_function_t _fself, kk_box_t _b_x203, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun480(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun480__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun480__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun480, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun480(kk_function_t _fself, kk_box_t _b_x203, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun480__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun480__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2 _y_x10018_1_257 = kk_std_core_types__tuple2_unbox(_b_x203, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x_x481 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10069(to_2, _y_x10018_1_257, _ctx);
  return kk_unit_box(_x_x481);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun483__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun483(kk_function_t _fself, kk_box_t _b_x222, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun483(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun483__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun483__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun483, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun485__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun485(kk_function_t _fself, kk_box_t _b_x211, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun485(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun485, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun485(kk_function_t _fself, kk_box_t _b_x211, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _b_x206_207;
  kk_std_core_types__list _x_x486;
  kk_std_os_path__path _match_x288;
  kk_box_t _x_x487 = kk_box_dup(_b_x211, _ctx); /*8579*/
  _match_x288 = kk_std_os_path__path_unbox(_x_x487, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1_1 = _match_x288.parts;
    kk_std_core_types__list_dup(_x_1_1, _ctx);
    kk_std_os_path__path_drop(_match_x288, _ctx);
    _x_x486 = _x_1_1; /*list<string>*/
  }
  _b_x206_207 = kk_std_core_list_take(_x_x486, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x488;
  kk_string_t _x_x489 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x491;
  kk_std_core_types__optional _match_x286 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x206_207, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x286, _ctx)) {
    kk_box_t _box_x208 = _match_x286._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_115_1 = kk_std_core_types__list_unbox(_box_x208, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_115_1, _ctx);
    kk_std_core_types__optional_drop(_match_x286, _ctx);
    kk_box_drop(_b_x211, _ctx);
    _x_x491 = _uniq_parts_115_1; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x286, _ctx);
    kk_std_os_path__path _match_x287 = kk_std_os_path__path_unbox(_b_x211, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0_1 = _match_x287.parts;
      kk_std_core_types__list_dup(_x_0_1, _ctx);
      kk_std_os_path__path_drop(_match_x287, _ctx);
      _x_x491 = _x_0_1; /*list<string>*/
    }
  }
  _x_x488 = kk_std_os_path__new_Path(_x_x489, _x_x491, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x488, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun496__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun496(kk_function_t _fself, kk_box_t _b_x218, kk_box_t _b_x219, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun496(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun496, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun496(kk_function_t _fself, kk_box_t _b_x218, kk_box_t _b_x219, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x_x497;
  kk_std_os_path__path _x_x498 = kk_std_os_path__path_unbox(_b_x218, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x499 = kk_std_os_path__path_unbox(_b_x219, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x497 = kk_std_os_path__lp__fs__rp_(_x_x498, _x_x499, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x497, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun483(kk_function_t _fself, kk_box_t _b_x222, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun483__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun483__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_10060_0;
  kk_box_t _x_x484;
  kk_box_t _x_x492 = kk_box_dup(_b_x222, _ctx); /*2691*/
  _x_x484 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun485(_ctx), _x_x492, _ctx); /*8580*/
  _x_x2_10060_0 = kk_std_os_path__path_unbox(_x_x484, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x493 = kk_std_os_path__path_unbox(_b_x222, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x494;
  kk_box_t _x_x495 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun496(_ctx), kk_std_os_path__path_box(to_2, _ctx), kk_std_os_path__path_box(_x_x2_10060_0, _ctx), _ctx); /*8647*/
  _x_x494 = kk_std_os_path__path_unbox(_x_x495, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(_x_x493, _x_x494, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun501__t {
  struct kk_function_s _base;
  kk_std_core_types__list dirs_1;
  kk_std_os_path__path to_2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun501(kk_function_t _fself, kk_box_t _b_x230, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun501(kk_std_core_types__list dirs_1, kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun501__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun501__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun501, kk_context());
  _self->dirs_1 = dirs_1;
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun501(kk_function_t _fself, kk_box_t _b_x230, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun501__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun501__t*, _fself, _ctx);
  kk_std_core_types__list dirs_1 = _self->dirs_1; /* list<std/os/path/path> */
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core_types__list_dup(dirs_1, _ctx);kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_unit_t wild___0_1_258 = kk_Unit;
  kk_unit_unbox(_b_x230);
  kk_unit_t _x_x502 = kk_Unit;
  kk_std_os_dir__mlift_copy_directory_10068(dirs_1, to_2, wild___0_1_258, _ctx);
  return kk_unit_box(_x_x502);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun503__t {
  struct kk_function_s _base;
  kk_std_os_path__path to_2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun503(kk_function_t _fself, kk_box_t _b_x247, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun503(kk_std_os_path__path to_2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun503__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun503__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun503, kk_context());
  _self->to_2 = to_2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun505__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun505(kk_function_t _fself, kk_box_t _b_x236, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun505(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun505, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun505(kk_function_t _fself, kk_box_t _b_x236, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _b_x231_232;
  kk_std_core_types__list _x_x506;
  kk_std_os_path__path _match_x285;
  kk_box_t _x_x507 = kk_box_dup(_b_x236, _ctx); /*8579*/
  _match_x285 = kk_std_os_path__path_unbox(_x_x507, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1_0_0 = _match_x285.parts;
    kk_std_core_types__list_dup(_x_1_0_0, _ctx);
    kk_std_os_path__path_drop(_match_x285, _ctx);
    _x_x506 = _x_1_0_0; /*list<string>*/
  }
  _b_x231_232 = kk_std_core_list_take(_x_x506, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x508;
  kk_string_t _x_x509 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x511;
  kk_std_core_types__optional _match_x283 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x231_232, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x283, _ctx)) {
    kk_box_t _box_x233 = _match_x283._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_115_0_0 = kk_std_core_types__list_unbox(_box_x233, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_115_0_0, _ctx);
    kk_std_core_types__optional_drop(_match_x283, _ctx);
    kk_box_drop(_b_x236, _ctx);
    _x_x511 = _uniq_parts_115_0_0; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x283, _ctx);
    kk_std_os_path__path _match_x284 = kk_std_os_path__path_unbox(_b_x236, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0_0_0 = _match_x284.parts;
      kk_std_core_types__list_dup(_x_0_0_0, _ctx);
      kk_std_os_path__path_drop(_match_x284, _ctx);
      _x_x511 = _x_0_0_0; /*list<string>*/
    }
  }
  _x_x508 = kk_std_os_path__new_Path(_x_x509, _x_x511, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x508, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun516__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun516(kk_function_t _fself, kk_box_t _b_x243, kk_box_t _b_x244, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun516(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun516, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun516(kk_function_t _fself, kk_box_t _b_x243, kk_box_t _b_x244, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x_x517;
  kk_std_os_path__path _x_x518 = kk_std_os_path__path_unbox(_b_x243, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x519 = kk_std_os_path__path_unbox(_b_x244, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x517 = kk_std_os_path__lp__fs__rp_(_x_x518, _x_x519, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x517, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun503(kk_function_t _fself, kk_box_t _b_x247, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun503__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun503__t*, _fself, _ctx);
  kk_std_os_path__path to_2 = _self->to_2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to_2, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x_x2_0_10063_0;
  kk_box_t _x_x504;
  kk_box_t _x_x512 = kk_box_dup(_b_x247, _ctx); /*2691*/
  _x_x504 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun505(_ctx), _x_x512, _ctx); /*8580*/
  _x_x2_0_10063_0 = kk_std_os_path__path_unbox(_x_x504, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x513 = kk_std_os_path__path_unbox(_b_x247, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x514;
  kk_box_t _x_x515 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun516(_ctx), kk_std_os_path__path_box(to_2, _ctx), kk_std_os_path__path_box(_x_x2_0_10063_0, _ctx), _ctx); /*8647*/
  _x_x514 = kk_std_os_path__path_unbox(_x_x515, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_directory(_x_x513, _x_x514, _ctx); return kk_Unit;
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir_0, kk_std_os_path__path to_2, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x_1_10081 = kk_Unit;
  kk_std_os_path__path _x_x466 = kk_std_os_path__path_dup(to_2, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x_x466, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x467 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun468(dir_0, to_2, _ctx), _ctx); /*2978*/
    kk_unit_unbox(_x_x467); return kk_Unit;
  }
  {
    kk_std_core_types__list all_0;
    kk_box_t _x_x470 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun471(_ctx), kk_std_os_path__path_box(dir_0, _ctx), _ctx); /*8580*/
    all_0 = kk_std_core_types__list_unbox(_x_x470, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__tuple2 x_2_10084;
    kk_function_t _brw_x289 = kk_std_os_dir_new_copy_directory_fun474(_ctx); /*(2453) -> 2454 bool*/;
    kk_std_core_types__tuple2 _brw_x290 = kk_std_core_list_partition(all_0, _brw_x289, _ctx); /*(list<2453>, list<2453>)*/;
    kk_function_drop(_brw_x289, _ctx);
    x_2_10084 = _brw_x290; /*(list<std/os/path/path>, list<std/os/path/path>)*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__tuple2_drop(x_2_10084, _ctx);
      kk_box_t _x_x479 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun480(to_2, _ctx), _ctx); /*2978*/
      kk_unit_unbox(_x_x479); return kk_Unit;
    }
    {
      kk_box_t _box_x204 = x_2_10084.fst;
      kk_box_t _box_x205 = x_2_10084.snd;
      kk_std_core_types__list dirs_1 = kk_std_core_types__list_unbox(_box_x204, KK_BORROWED, _ctx);
      kk_std_core_types__list files_0 = kk_std_core_types__list_unbox(_box_x205, KK_BORROWED, _ctx);
      kk_std_core_types__list_dup(dirs_1, _ctx);
      kk_std_core_types__list_dup(files_0, _ctx);
      kk_std_core_types__tuple2_drop(x_2_10084, _ctx);
      kk_unit_t x_3_10087 = kk_Unit;
      kk_function_t _x_x482;
      kk_std_os_path__path_dup(to_2, _ctx);
      _x_x482 = kk_std_os_dir_new_copy_directory_fun483(to_2, _ctx); /*(2691) -> 2692 ()*/
      kk_std_core_list_foreach(files_0, _x_x482, _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x_x500 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun501(dirs_1, to_2, _ctx), _ctx); /*2978*/
        kk_unit_unbox(_x_x500); return kk_Unit;
      }
      {
        kk_std_core_list_foreach(dirs_1, kk_std_os_dir_new_copy_directory_fun503(to_2, _ctx), _ctx); return kk_Unit;
      }
    }
  }
}
 
// Copy a file to a directory


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun521__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun521(kk_function_t _fself, kk_box_t _b_x265, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun521(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun521, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun521(kk_function_t _fself, kk_box_t _b_x265, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__list _b_x260_261;
  kk_std_core_types__list _x_x522;
  kk_std_os_path__path _match_x279;
  kk_box_t _x_x523 = kk_box_dup(_b_x265, _ctx); /*8579*/
  _match_x279 = kk_std_os_path__path_unbox(_x_x523, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core_types__list _x_1 = _match_x279.parts;
    kk_std_core_types__list_dup(_x_1, _ctx);
    kk_std_os_path__path_drop(_match_x279, _ctx);
    _x_x522 = _x_1; /*list<string>*/
  }
  _b_x260_261 = kk_std_core_list_take(_x_x522, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x_x524;
  kk_string_t _x_x525 = kk_string_empty(); /*string*/
  kk_std_core_types__list _x_x527;
  kk_std_core_types__optional _match_x277 = kk_std_core_types__new_Optional(kk_std_core_types__list_box(_b_x260_261, _ctx), _ctx); /*? 7*/;
  if (kk_std_core_types__is_Optional(_match_x277, _ctx)) {
    kk_box_t _box_x262 = _match_x277._cons._Optional.value;
    kk_std_core_types__list _uniq_parts_115 = kk_std_core_types__list_unbox(_box_x262, KK_BORROWED, _ctx);
    kk_std_core_types__list_dup(_uniq_parts_115, _ctx);
    kk_std_core_types__optional_drop(_match_x277, _ctx);
    kk_box_drop(_b_x265, _ctx);
    _x_x527 = _uniq_parts_115; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_x277, _ctx);
    kk_std_os_path__path _match_x278 = kk_std_os_path__path_unbox(_b_x265, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core_types__list _x_0 = _match_x278.parts;
      kk_std_core_types__list_dup(_x_0, _ctx);
      kk_std_os_path__path_drop(_match_x278, _ctx);
      _x_x527 = _x_0; /*list<string>*/
    }
  }
  _x_x524 = kk_std_os_path__new_Path(_x_x525, _x_x527, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x524, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun532__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun532(kk_function_t _fself, kk_box_t _b_x272, kk_box_t _b_x273, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun532(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun532, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun532(kk_function_t _fself, kk_box_t _b_x272, kk_box_t _b_x273, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x_x533;
  kk_std_os_path__path _x_x534 = kk_std_os_path__path_unbox(_b_x272, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x535 = kk_std_os_path__path_unbox(_b_x273, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x533 = kk_std_os_path__lp__fs__rp_(_x_x534, _x_x535, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x_x533, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_std_os_path__path _x_x2_10066;
  kk_box_t _x_x520;
  kk_box_t _x_x528;
  kk_std_os_path__path _x_x529 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x_x528 = kk_std_os_path__path_box(_x_x529, _ctx); /*8579*/
  _x_x520 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_to_dir_fun521(_ctx), _x_x528, _ctx); /*8580*/
  _x_x2_10066 = kk_std_os_path__path_unbox(_x_x520, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x_x530;
  kk_box_t _x_x531 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_to_dir_fun532(_ctx), kk_std_os_path__path_box(dir, _ctx), kk_std_os_path__path_box(_x_x2_10066, _ctx), _ctx); /*8647*/
  _x_x530 = kk_std_os_path__path_unbox(_x_x531, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(from, _x_x530, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
