// Koka generated module: std/os/file, koka version: 3.1.2, platform: 64-bit
#include "std_os_file.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_exn__error kk_os_read_text_file_error( kk_string_t path, kk_context_t* ctx ) {
  kk_string_t content;
  const int err = kk_os_read_text_file(path,&content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_string_box(content),ctx);
}

static kk_std_core_exn__error kk_os_write_text_file_error( kk_string_t path, kk_string_t content, kk_context_t* ctx ) {
  const int err = kk_os_write_text_file(path,content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}


kk_std_core_exn__exception kk_std_os_file_prepend(kk_std_core_exn__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x_x84;
  kk_string_t _x_x85;
  kk_string_t _x_x86;
  kk_define_string_literal(, _s_x87, 2, ": ", _ctx)
  _x_x86 = kk_string_dup(_s_x87, _ctx); /*string*/
  kk_string_t _x_x88;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x_x88 = _x; /*string*/
  }
  _x_x85 = kk_std_core_types__lp__plus__plus__rp_(_x_x86, _x_x88, _ctx); /*string*/
  _x_x84 = kk_std_core_types__lp__plus__plus__rp_(pre, _x_x85, _ctx); /*string*/
  kk_std_core_exn__exception_info _x_x89;
  {
    kk_std_core_exn__exception_info _x_0 = exn.info;
    kk_std_core_exn__exception_info_dup(_x_0, _ctx);
    kk_std_core_exn__exception_drop(exn, _ctx);
    _x_x89 = _x_0; /*exception-info*/
  }
  return kk_std_core_exn__new_Exception(_x_x84, _x_x89, _ctx);
}

kk_std_core_exn__error kk_std_os_file_read_text_file_err(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys error<string> */ 
  return kk_os_read_text_file_error(path,kk_context());
}
 
// Read a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_read_text_file_fun91__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun91(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun91(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun91, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun91(kk_function_t _fself, kk_box_t _b_x2, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x92;
  kk_std_os_path__path _x_x93 = kk_std_os_path__path_unbox(_b_x2, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x92 = kk_std_os_path_string(_x_x93, _ctx); /*string*/
  return kk_string_box(_x_x92);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun97__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun97(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun97(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun97, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun97(kk_function_t _fself, kk_box_t _b_x7, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__error _x_x98;
  kk_string_t _x_x99 = kk_string_unbox(_b_x7); /*string*/
  _x_x98 = kk_std_os_file_read_text_file_err(_x_x99, _ctx); /*error<string>*/
  return kk_std_core_exn__error_box(_x_x98, _ctx);
}

kk_string_t kk_std_os_file_read_text_file(kk_std_os_path__path path, kk_context_t* _ctx) { /* (path : std/os/path/path) -> <exn,fsys> string */ 
  kk_string_t _x_x1_10126;
  kk_box_t _x_x90;
  kk_box_t _x_x94;
  kk_std_os_path__path _x_x95 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
  _x_x94 = kk_std_os_path__path_box(_x_x95, _ctx); /*8579*/
  _x_x90 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun91(_ctx), _x_x94, _ctx); /*8580*/
  _x_x1_10126 = kk_string_unbox(_x_x90); /*string*/
  kk_std_core_exn__error _match_x79;
  kk_box_t _x_x96 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun97(_ctx), kk_string_box(_x_x1_10126), _ctx); /*8580*/
  _match_x79 = kk_std_core_exn__error_unbox(_x_x96, KK_OWNED, _ctx); /*error<string>*/
  if (kk_std_core_exn__is_Error(_match_x79, _ctx)) {
    kk_std_core_exn__exception exn = _match_x79._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(_match_x79, _ctx);
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_string_t x;
    kk_string_t _x_x100 = kk_std_os_path_string(path, _ctx); /*string*/
    x = kk_std_core_show_string_fs_show(_x_x100, _ctx); /*string*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_string_t _x_x2_10129;
    kk_string_t _x_x101;
    kk_define_string_literal(, _s_x102, 25, "unable to read text file ", _ctx)
    _x_x101 = kk_string_dup(_s_x102, _ctx); /*string*/
    _x_x2_10129 = kk_std_core_types__lp__plus__plus__rp_(_x_x101, x, _ctx); /*string*/
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_std_core_exn__exception x_0;
    kk_string_t _x_x103;
    kk_string_t _x_x104;
    kk_string_t _x_x105;
    kk_define_string_literal(, _s_x106, 2, ": ", _ctx)
    _x_x105 = kk_string_dup(_s_x106, _ctx); /*string*/
    kk_string_t _x_x107;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x_x107 = _x; /*string*/
    }
    _x_x104 = kk_std_core_types__lp__plus__plus__rp_(_x_x105, _x_x107, _ctx); /*string*/
    _x_x103 = kk_std_core_types__lp__plus__plus__rp_(_x_x2_10129, _x_x104, _ctx); /*string*/
    kk_std_core_exn__exception_info _x_x108;
    {
      kk_std_core_exn__exception_info _x_0 = exn.info;
      kk_std_core_exn__exception_info_dup(_x_0, _ctx);
      kk_std_core_exn__exception_drop(exn, _ctx);
      _x_x108 = _x_0; /*exception-info*/
    }
    x_0 = kk_std_core_exn__new_Exception(_x_x103, _x_x108, _ctx); /*exception*/
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_std_core_hnd__ev ev_10145 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x109;
    {
      struct kk_std_core_hnd_Ev* _con_x110 = kk_std_core_hnd__as_Ev(ev_10145, _ctx);
      kk_box_t _box_x8 = _con_x110->hnd;
      int32_t m = _con_x110->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x8, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x80;
      kk_std_core_hnd__clause1 _brw_x81 = kk_std_core_exn__select_throw_exn(h, _ctx); /*hnd/clause1<exception,403,exn,404,405>*/;
      kk_std_core_exn__exn_drop(h, _ctx);
      _match_x80 = _brw_x81; /*hnd/clause1<exception,403,exn,404,405>*/
      {
        kk_function_t _fun_unbox_x12 = _match_x80.clause;
        _x_x109 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x12, (_fun_unbox_x12, m, ev_10145, kk_std_core_exn__exception_box(x_0, _ctx), _ctx), _ctx); /*46*/
      }
    }
    return kk_string_unbox(_x_x109);
  }
  {
    kk_box_t _box_x16 = _match_x79._cons.Ok.result;
    kk_string_t content = kk_string_unbox(_box_x16);
    kk_std_os_path__path_drop(path, _ctx);
    kk_string_dup(content, _ctx);
    kk_std_core_exn__error_drop(_match_x79, _ctx);
    return content;
  }
}

kk_std_core_exn__error kk_std_os_file_write_text_file_err(kk_string_t path, kk_string_t content, kk_context_t* _ctx) { /* (path : string, content : string) -> fsys error<()> */ 
  return kk_os_write_text_file_error(path,content,kk_context());
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_file__mlift_write_text_file_10139_fun112__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift_write_text_file_10139_fun112(kk_function_t _fself, kk_box_t _b_x21, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift_write_text_file_10139_fun112(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift_write_text_file_10139_fun112, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift_write_text_file_10139_fun112(kk_function_t _fself, kk_box_t _b_x21, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x113;
  kk_std_os_path__path _x_x114 = kk_std_os_path__path_unbox(_b_x21, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x113 = kk_std_os_path_string(_x_x114, _ctx); /*string*/
  return kk_string_box(_x_x113);
}


// lift anonymous function
struct kk_std_os_file__mlift_write_text_file_10139_fun118__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift_write_text_file_10139_fun118(kk_function_t _fself, kk_box_t _b_x27, kk_box_t _b_x28, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift_write_text_file_10139_fun118(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift_write_text_file_10139_fun118, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift_write_text_file_10139_fun118(kk_function_t _fself, kk_box_t _b_x27, kk_box_t _b_x28, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__error _x_x119;
  kk_string_t _x_x120 = kk_string_unbox(_b_x27); /*string*/
  kk_string_t _x_x121 = kk_string_unbox(_b_x28); /*string*/
  _x_x119 = kk_std_os_file_write_text_file_err(_x_x120, _x_x121, _ctx); /*error<()>*/
  return kk_std_core_exn__error_box(_x_x119, _ctx);
}

kk_unit_t kk_std_os_file__mlift_write_text_file_10139(kk_string_t content, kk_std_os_path__path path, kk_unit_t _c_x10113, kk_context_t* _ctx) { /* (content : string, path : std/os/path/path, ()) -> () */ 
  kk_string_t _x_x1_1_10133;
  kk_box_t _x_x111;
  kk_box_t _x_x115;
  kk_std_os_path__path _x_x116 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
  _x_x115 = kk_std_os_path__path_box(_x_x116, _ctx); /*8579*/
  _x_x111 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift_write_text_file_10139_fun112(_ctx), _x_x115, _ctx); /*8580*/
  _x_x1_1_10133 = kk_string_unbox(_x_x111); /*string*/
  kk_std_core_exn__error _match_x76;
  kk_box_t _x_x117 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift_write_text_file_10139_fun118(_ctx), kk_string_box(_x_x1_1_10133), kk_string_box(content), _ctx); /*8647*/
  _match_x76 = kk_std_core_exn__error_unbox(_x_x117, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core_exn__is_Error(_match_x76, _ctx)) {
    kk_std_core_exn__exception exn = _match_x76._cons.Error.exception;
    kk_std_core_exn__exception_dup(exn, _ctx);
    kk_std_core_exn__error_drop(_match_x76, _ctx);
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_string_t x;
    kk_string_t _x_x122 = kk_std_os_path_string(path, _ctx); /*string*/
    x = kk_std_core_show_string_fs_show(_x_x122, _ctx); /*string*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_string_t _x_x2_0_10137;
    kk_string_t _x_x123;
    kk_define_string_literal(, _s_x124, 26, "unable to write text file ", _ctx)
    _x_x123 = kk_string_dup(_s_x124, _ctx); /*string*/
    _x_x2_0_10137 = kk_std_core_types__lp__plus__plus__rp_(_x_x123, x, _ctx); /*string*/
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_std_core_exn__exception x_0;
    kk_string_t _x_x125;
    kk_string_t _x_x126;
    kk_string_t _x_x127;
    kk_define_string_literal(, _s_x128, 2, ": ", _ctx)
    _x_x127 = kk_string_dup(_s_x128, _ctx); /*string*/
    kk_string_t _x_x129;
    {
      kk_string_t _x_2 = exn.message;
      kk_string_dup(_x_2, _ctx);
      _x_x129 = _x_2; /*string*/
    }
    _x_x126 = kk_std_core_types__lp__plus__plus__rp_(_x_x127, _x_x129, _ctx); /*string*/
    _x_x125 = kk_std_core_types__lp__plus__plus__rp_(_x_x2_0_10137, _x_x126, _ctx); /*string*/
    kk_std_core_exn__exception_info _x_x130;
    {
      kk_std_core_exn__exception_info _x_3 = exn.info;
      kk_std_core_exn__exception_info_dup(_x_3, _ctx);
      kk_std_core_exn__exception_drop(exn, _ctx);
      _x_x130 = _x_3; /*exception-info*/
    }
    x_0 = kk_std_core_exn__new_Exception(_x_x125, _x_x130, _ctx); /*exception*/
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_std_core_hnd__ev ev_10153 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
    kk_box_t _x_x131;
    {
      struct kk_std_core_hnd_Ev* _con_x132 = kk_std_core_hnd__as_Ev(ev_10153, _ctx);
      kk_box_t _box_x29 = _con_x132->hnd;
      int32_t m = _con_x132->marker;
      kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x29, KK_BORROWED, _ctx);
      kk_std_core_exn__exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_x77;
      kk_std_core_hnd__clause1 _brw_x78 = kk_std_core_exn__select_throw_exn(h, _ctx); /*hnd/clause1<exception,403,exn,404,405>*/;
      kk_std_core_exn__exn_drop(h, _ctx);
      _match_x77 = _brw_x78; /*hnd/clause1<exception,403,exn,404,405>*/
      {
        kk_function_t _fun_unbox_x33 = _match_x77.clause;
        _x_x131 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x33, (_fun_unbox_x33, m, ev_10153, kk_std_core_exn__exception_box(x_0, _ctx), _ctx), _ctx); /*46*/
      }
    }
    kk_unit_unbox(_x_x131); return kk_Unit;
  }
  {
    kk_std_os_path__path_drop(path, _ctx);
    kk_std_core_exn__error_drop(_match_x76, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Write a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_write_text_file_fun142__t {
  struct kk_function_s _base;
  kk_string_t content;
  kk_std_os_path__path path;
};
static kk_box_t kk_std_os_file_write_text_file_fun142(kk_function_t _fself, kk_box_t _b_x46, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun142(kk_string_t content, kk_std_os_path__path path, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun142__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun142__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_file_write_text_file_fun142, kk_context());
  _self->content = content;
  _self->path = path;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun142(kk_function_t _fself, kk_box_t _b_x46, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun142__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun142__t*, _fself, _ctx);
  kk_string_t content = _self->content; /* string */
  kk_std_os_path__path path = _self->path; /* std/os/path/path */
  kk_drop_match(_self, {kk_string_dup(content, _ctx);kk_std_os_path__path_dup(path, _ctx);}, {}, _ctx)
  kk_unit_t _c_x10113_69 = kk_Unit;
  kk_unit_unbox(_b_x46);
  kk_unit_t _x_x143 = kk_Unit;
  kk_std_os_file__mlift_write_text_file_10139(content, path, _c_x10113_69, _ctx);
  return kk_unit_box(_x_x143);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun145__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun145(kk_function_t _fself, kk_box_t _b_x49, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun145(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun145, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun145(kk_function_t _fself, kk_box_t _b_x49, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x_x146;
  kk_std_os_path__path _x_x147 = kk_std_os_path__path_unbox(_b_x49, KK_OWNED, _ctx); /*std/os/path/path*/
  _x_x146 = kk_std_os_path_string(_x_x147, _ctx); /*string*/
  return kk_string_box(_x_x146);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun151__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun151(kk_function_t _fself, kk_box_t _b_x55, kk_box_t _b_x56, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun151(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun151, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun151(kk_function_t _fself, kk_box_t _b_x55, kk_box_t _b_x56, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_exn__error _x_x152;
  kk_string_t _x_x153 = kk_string_unbox(_b_x55); /*string*/
  kk_string_t _x_x154 = kk_string_unbox(_b_x56); /*string*/
  _x_x152 = kk_std_os_file_write_text_file_err(_x_x153, _x_x154, _ctx); /*error<()>*/
  return kk_std_core_exn__error_box(_x_x152, _ctx);
}

kk_unit_t kk_std_os_file_write_text_file(kk_std_os_path__path path, kk_string_t content, kk_std_core_types__optional create_dir, kk_context_t* _ctx) { /* (path : std/os/path/path, content : string, create-dir : ? bool) -> <exn,fsys> () */ 
  kk_unit_t x_10156 = kk_Unit;
  if (kk_std_core_types__is_Optional(create_dir, _ctx)) {
    kk_box_t _box_x40 = create_dir._cons._Optional.value;
    bool _uniq_create_dir_158 = kk_bool_unbox(_box_x40);
    kk_std_core_types__optional_drop(create_dir, _ctx);
    if (_uniq_create_dir_158) {
      kk_evv_t w = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
      kk_unit_t keep = kk_Unit;
      kk_evv_set(w,kk_context());
      kk_std_os_path__path _x_x133;
      kk_string_t _x_x134;
      kk_std_core_types__optional _match_x75 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
      if (kk_std_core_types__is_Optional(_match_x75, _ctx)) {
        kk_box_t _box_x41 = _match_x75._cons._Optional.value;
        kk_string_t _uniq_root_108 = kk_string_unbox(_box_x41);
        kk_string_dup(_uniq_root_108, _ctx);
        kk_std_core_types__optional_drop(_match_x75, _ctx);
        _x_x134 = _uniq_root_108; /*string*/
      }
      else {
        kk_std_core_types__optional_drop(_match_x75, _ctx);
        {
          kk_string_t _x_0 = path.root;
          kk_string_dup(_x_0, _ctx);
          _x_x134 = _x_0; /*string*/
        }
      }
      kk_std_core_types__list _x_x135;
      {
        kk_std_core_types__list _x = path.parts;
        kk_std_core_types__list_dup(_x, _ctx);
        if (kk_std_core_types__is_Cons(_x, _ctx)) {
          struct kk_std_core_types_Cons* _con_x136 = kk_std_core_types__as_Cons(_x, _ctx);
          kk_box_t _box_x42 = _con_x136->head;
          kk_std_core_types__list xx = _con_x136->tail;
          if kk_likely(kk_datatype_ptr_is_unique(_x, _ctx)) {
            kk_box_drop(_box_x42, _ctx);
            kk_datatype_ptr_free(_x, _ctx);
          }
          else {
            kk_std_core_types__list_dup(xx, _ctx);
            kk_datatype_ptr_decref(_x, _ctx);
          }
          _x_x135 = xx; /*list<string>*/
        }
        else {
          _x_x135 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
        }
      }
      _x_x133 = kk_std_os_path__new_Path(_x_x134, _x_x135, _ctx); /*std/os/path/path*/
      kk_std_os_dir_ensure_dir(_x_x133, _ctx);
    }
    else {
      
    }
  }
  else {
    kk_std_core_types__optional_drop(create_dir, _ctx);
    kk_evv_t w_0 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
    kk_unit_t keep_0 = kk_Unit;
    kk_evv_set(w_0,kk_context());
    kk_std_os_path__path _x_x137;
    kk_string_t _x_x138;
    kk_std_core_types__optional _match_x74 = kk_std_core_types__new_None(_ctx); /*forall<a> ? a*/;
    if (kk_std_core_types__is_Optional(_match_x74, _ctx)) {
      kk_box_t _box_x43 = _match_x74._cons._Optional.value;
      kk_string_t _uniq_root_108_0 = kk_string_unbox(_box_x43);
      kk_string_dup(_uniq_root_108_0, _ctx);
      kk_std_core_types__optional_drop(_match_x74, _ctx);
      _x_x138 = _uniq_root_108_0; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(_match_x74, _ctx);
      {
        kk_string_t _x_0_0 = path.root;
        kk_string_dup(_x_0_0, _ctx);
        _x_x138 = _x_0_0; /*string*/
      }
    }
    kk_std_core_types__list _x_x139;
    {
      kk_std_core_types__list _x_1 = path.parts;
      kk_std_core_types__list_dup(_x_1, _ctx);
      if (kk_std_core_types__is_Cons(_x_1, _ctx)) {
        struct kk_std_core_types_Cons* _con_x140 = kk_std_core_types__as_Cons(_x_1, _ctx);
        kk_box_t _box_x44 = _con_x140->head;
        kk_std_core_types__list xx_0 = _con_x140->tail;
        if kk_likely(kk_datatype_ptr_is_unique(_x_1, _ctx)) {
          kk_box_drop(_box_x44, _ctx);
          kk_datatype_ptr_free(_x_1, _ctx);
        }
        else {
          kk_std_core_types__list_dup(xx_0, _ctx);
          kk_datatype_ptr_decref(_x_1, _ctx);
        }
        _x_x139 = xx_0; /*list<string>*/
      }
      else {
        _x_x139 = kk_std_core_types__new_Nil(_ctx); /*list<string>*/
      }
    }
    _x_x137 = kk_std_os_path__new_Path(_x_x138, _x_x139, _ctx); /*std/os/path/path*/
    kk_std_os_dir_ensure_dir(_x_x137, _ctx);
  }
  if (kk_yielding(kk_context())) {
    kk_box_t _x_x141 = kk_std_core_hnd_yield_extend(kk_std_os_file_new_write_text_file_fun142(content, path, _ctx), _ctx); /*2978*/
    kk_unit_unbox(_x_x141); return kk_Unit;
  }
  {
    kk_string_t _x_x1_1_10133;
    kk_box_t _x_x144;
    kk_box_t _x_x148;
    kk_std_os_path__path _x_x149 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
    _x_x148 = kk_std_os_path__path_box(_x_x149, _ctx); /*8579*/
    _x_x144 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun145(_ctx), _x_x148, _ctx); /*8580*/
    _x_x1_1_10133 = kk_string_unbox(_x_x144); /*string*/
    kk_std_core_exn__error _match_x71;
    kk_box_t _x_x150 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun151(_ctx), kk_string_box(_x_x1_1_10133), kk_string_box(content), _ctx); /*8647*/
    _match_x71 = kk_std_core_exn__error_unbox(_x_x150, KK_OWNED, _ctx); /*error<()>*/
    if (kk_std_core_exn__is_Error(_match_x71, _ctx)) {
      kk_std_core_exn__exception exn = _match_x71._cons.Error.exception;
      kk_std_core_exn__exception_dup(exn, _ctx);
      kk_std_core_exn__error_drop(_match_x71, _ctx);
      kk_evv_t w_1 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
      kk_string_t x_2;
      kk_string_t _x_x155 = kk_std_os_path_string(path, _ctx); /*string*/
      x_2 = kk_std_core_show_string_fs_show(_x_x155, _ctx); /*string*/
      kk_unit_t keep_1 = kk_Unit;
      kk_evv_set(w_1,kk_context());
      kk_string_t _x_x2_0_10137;
      kk_string_t _x_x156;
      kk_define_string_literal(, _s_x157, 26, "unable to write text file ", _ctx)
      _x_x156 = kk_string_dup(_s_x157, _ctx); /*string*/
      _x_x2_0_10137 = kk_std_core_types__lp__plus__plus__rp_(_x_x156, x_2, _ctx); /*string*/
      kk_evv_t w_2 = kk_evv_swap_create0(kk_context()); /*hnd/evv<<exn,fsys>>*/;
      kk_std_core_exn__exception x_3;
      kk_string_t _x_x158;
      kk_string_t _x_x159;
      kk_string_t _x_x160;
      kk_define_string_literal(, _s_x161, 2, ": ", _ctx)
      _x_x160 = kk_string_dup(_s_x161, _ctx); /*string*/
      kk_string_t _x_x162;
      {
        kk_string_t _x_2 = exn.message;
        kk_string_dup(_x_2, _ctx);
        _x_x162 = _x_2; /*string*/
      }
      _x_x159 = kk_std_core_types__lp__plus__plus__rp_(_x_x160, _x_x162, _ctx); /*string*/
      _x_x158 = kk_std_core_types__lp__plus__plus__rp_(_x_x2_0_10137, _x_x159, _ctx); /*string*/
      kk_std_core_exn__exception_info _x_x163;
      {
        kk_std_core_exn__exception_info _x_3 = exn.info;
        kk_std_core_exn__exception_info_dup(_x_3, _ctx);
        kk_std_core_exn__exception_drop(exn, _ctx);
        _x_x163 = _x_3; /*exception-info*/
      }
      x_3 = kk_std_core_exn__new_Exception(_x_x158, _x_x163, _ctx); /*exception*/
      kk_unit_t keep_2 = kk_Unit;
      kk_evv_set(w_2,kk_context());
      kk_std_core_hnd__ev ev_10168 = kk_evv_at(((KK_IZ(0))),kk_context()); /*hnd/ev<exn>*/;
      kk_box_t _x_x164;
      {
        struct kk_std_core_hnd_Ev* _con_x165 = kk_std_core_hnd__as_Ev(ev_10168, _ctx);
        kk_box_t _box_x57 = _con_x165->hnd;
        int32_t m = _con_x165->marker;
        kk_std_core_exn__exn h = kk_std_core_exn__exn_unbox(_box_x57, KK_BORROWED, _ctx);
        kk_std_core_exn__exn_dup(h, _ctx);
        kk_std_core_hnd__clause1 _match_x72;
        kk_std_core_hnd__clause1 _brw_x73 = kk_std_core_exn__select_throw_exn(h, _ctx); /*hnd/clause1<exception,403,exn,404,405>*/;
        kk_std_core_exn__exn_drop(h, _ctx);
        _match_x72 = _brw_x73; /*hnd/clause1<exception,403,exn,404,405>*/
        {
          kk_function_t _fun_unbox_x61 = _match_x72.clause;
          _x_x164 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x61, (_fun_unbox_x61, m, ev_10168, kk_std_core_exn__exception_box(x_3, _ctx), _ctx), _ctx); /*46*/
        }
      }
      kk_unit_unbox(_x_x164); return kk_Unit;
    }
    {
      kk_std_os_path__path_drop(path, _ctx);
      kk_std_core_exn__error_drop(_match_x71, _ctx);
      kk_Unit; return kk_Unit;
    }
  }
}

// initialization
void kk_std_os_file__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core_exn__init(_ctx);
  kk_std_core_bool__init(_ctx);
  kk_std_core_order__init(_ctx);
  kk_std_core_char__init(_ctx);
  kk_std_core_int__init(_ctx);
  kk_std_core_vector__init(_ctx);
  kk_std_core_string__init(_ctx);
  kk_std_core_sslice__init(_ctx);
  kk_std_core_list__init(_ctx);
  kk_std_core_maybe__init(_ctx);
  kk_std_core_either__init(_ctx);
  kk_std_core_tuple__init(_ctx);
  kk_std_core_show__init(_ctx);
  kk_std_core_debug__init(_ctx);
  kk_std_core_delayed__init(_ctx);
  kk_std_core_console__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  kk_std_os_dir__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_file__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_dir__done(_ctx);
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_console__done(_ctx);
  kk_std_core_delayed__done(_ctx);
  kk_std_core_debug__done(_ctx);
  kk_std_core_show__done(_ctx);
  kk_std_core_tuple__done(_ctx);
  kk_std_core_either__done(_ctx);
  kk_std_core_maybe__done(_ctx);
  kk_std_core_list__done(_ctx);
  kk_std_core_sslice__done(_ctx);
  kk_std_core_string__done(_ctx);
  kk_std_core_vector__done(_ctx);
  kk_std_core_int__done(_ctx);
  kk_std_core_char__done(_ctx);
  kk_std_core_order__done(_ctx);
  kk_std_core_bool__done(_ctx);
  kk_std_core_exn__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
